<?php 
/*
 * Book module for Allmice™ CMS
 * Version 1.2.5 (2019-07-17)
 * Copyright 2019 by Any Outline LTD
 * http://www.allmice.com/cms
 * Book module for Allmice CMS is released under the "GNU GENERAL PUBLIC LICENSE".
 * See LICENSE.TXT file in Allmice CMS Book module root directory for more details about the license.
 */
 ?>

<?php

include $pathCoreController."Controller.php";
include $pathCoreModel."Form.php";
include "core/includes/Model/"."DatabaseCms.php";
include $pathModuleModel."AppDatabase.php";
include $pathModuleModel."Sitemap.php";
include $pathModuleModel."SitemapForm.php";

class XmlSitemapController extends Controller
{

	public $dbConfig;
	public $modConfig;
	public $modLang;

	public function indexEvent()
	{

		$Database=$this->dbConfig;
		$appDb = new AppDatabase($Database['app_db']);

		$roleId=1;
		$sqlWhere="";
		$sqlWhere.=" AND p.role_id = ".$roleId."";
		$sqlWhere.=" AND r.module_name = '".$GLOBALS['modName']."'";

		$eventSet = $appDb->getModuleEventSet($sqlWhere);

		return array(
			'eventSet' => $eventSet,
		);

	}

	public function listEvent()
	{

		$modConfig=$this->modConfig;

		$Database=$this->dbConfig;
		$appDb = new AppDatabase($Database['app_db']);

		$smList = $appDb->getSitemapList();	

		return array(
			'sitemapList' => $smList,
		);

	}

	public function addEvent()
	{

		$form = new SitemapForm();
		$form->setUrl($GLOBALS['curUrl']);
		$form->setValue('save','Add sitemap structure');

		$Database=$this->dbConfig;
		$appDb = new AppDatabase($Database['app_db']);

		$sitemap = new Sitemap();
		$sitemap->id = 0;

		$curSmUrlIdList=array();
		$pageTitleList=array();
		$contentList=array();

		if (isset($_POST['save'])) {

			$form->updateForm();
			$form->validation($appDb->getValidityPatterns($GLOBALS['modName']),array());

			if ($form->isValid) {

				$formData=$form->getData();
				$sitemap->convertFormData($formData);

				$sitemap->changeFreq=$form->getValue('changeFreq');
				$sitemap->lastMod=$form->getValue('lastMod');
				$sitemap->priorSwitch=$form->getValue('priorSwitch');

				$smId=$appDb->saveSitemap($sitemap,$contentList);

				$url=$GLOBALS['baseUrl']."/xml-sitemap/edit/".$smId;
				$this->redirect($url, false);

			}
			else{
				$form->setErrorMessages();

			}

		}

		return array(
			'form' => $form,
		);

	}

	public function editEvent()
	{

//No need to display form or other changes after submit, 
//   because redirect will be made to the current URL after saving new changes to db and fresh data will be pulled from db.
//   This is admin module such redirect and pulling from db. makes the logic much easier, possible slower performance will be no issue, because few users (admins only).

		$id = 0;
		if(isset($GLOBALS['urlParts'][2])){
			$id = $GLOBALS['urlParts'][2];
			$id=(int)$id;
			if(!is_integer($id))
				$id=0;
		}
		$Other=$this->otherConfig;

		$messages=array();
		$pageList=array();
		$looseList=array();
		$contentList=array();
		$newLooseList=array();
		$newContentList=array();
		$looseCbValues=array();
		$contentCbValues=array();

		$contentUriList=array();

		$submitMessage="";

		$modConfig=$this->modConfig;

		$form = new SitemapForm();
		$form->setUrl($GLOBALS['curUrl']);
		$form->setValue('save','Update sitemap structure');

		$Database=$this->dbConfig;
		$appDb = new AppDatabase($Database['app_db']);

		$smDetails=$appDb->getSitemapDetails($id);

		$sitemap = new Sitemap();
		$sitemap->id = $id;

		if(count($smDetails)>0){

			$form->convertDbData($smDetails);
	//Sitemap makes sense if it contains URLs, which are accessible for anonymous role (role id is 2) only - bots can not log on
			$userRole=2;
	
			$pageList = $appDb->getWholeEntrySet($userRole);
	
		}
		else{
			$id = 0;
			$messages[]="Sitemap id is not correct.";
		}

		if (isset($_POST['save']) || isset($_POST['saveFile'])) {

			$form->updateForm();
			$form->validation($appDb->getValidityPatterns($GLOBALS['modName']),array());

			if ($form->isValid) {

				$formData=$form->getData();
				$sitemap->convertFormData($formData);

				$mesContent="Sitemap details were updated in database.";
				$mesType="success";
				$submitMessage=$sitemap->getMessage($mesContent,$mesType);

//Get all checkbox values
				if(isset($_POST['looseCb']))
					$looseCbValues=$_POST['looseCb'];
				if(isset($_POST['contentCb']))
					$contentCbValues=$_POST['contentCb'];

				for($i=0;$i<count($pageList);$i++){
					if(in_array($pageList[$i]['id'],$contentCbValues)){
						$pageList[$i]['status']="checked";
						$pageList[$i]['priorValue']=0.5;
						if (isset($_POST[('prior'.$pageList[$i]['id'])])){
							if(is_numeric($_POST[('prior'.$pageList[$i]['id'])]) && floatval($_POST[('prior'.$pageList[$i]['id'])])>=0 && floatval($_POST[('prior'.$pageList[$i]['id'])])<=1){
								$pageList[$i]['priorValue']=$_POST[('prior'.$pageList[$i]['id'])];
								if($pageList[$i]['priorValue']=="0")
									$pageList[$i]['priorValue']="0.0";
								elseif($pageList[$i]['priorValue']=="1")
									$pageList[$i]['priorValue']="1.0";
							}
							else{
								$mesContent="At least one of the priority values was not correct. Such values were replaced with 0.0. Changes were saved into database, but not into XML file.";
								$mesType="problem";
								$submitMessage=$sitemap->getMessage($mesContent,$mesType);
								$pageList[$i]['priorValue']="0.0";
							}
						}

						$contentList[]=$pageList[$i];
					}
					elseif(in_array($pageList[$i]['id'],$looseCbValues)){
						$pageList[$i]['status']="checked";
						$pageList[$i]['priorValue']=0.5;
						$contentList[]=$pageList[$i];
					}
					else{
						$looseList[]=$pageList[$i];
					}

				}

				$sitemap->editTime=time();

//Sorting by priority value
				foreach ($contentList as $key => $row) {
				    $sortValue2[$key]  = (int)$row['priorValue'];
				    $id2[$key] = $row['id'];
				}
				$sortValue2  = array_column($contentList, 'priorValue');
				$id2 = array_column($contentList, 'id');
				array_multisort($sortValue2, SORT_DESC, $id2, SORT_ASC, $contentList);

				$xmlCode=$sitemap->getXmlCode($sitemap,$contentList);
				$form->setValue('output',$xmlCode);

				if (isset($_POST['saveFile'])) {

					if($mesType=="success"){
						$xmlCode=$form->specialCharsDecode($xmlCode);
						$submitMessage=$sitemap->saveFile($sitemap,$xmlCode);
	
						$filePath=$sitemap->smPath.'/'.$sitemap->smFileName;
	
						if (is_writable($sitemap->smPath)){
							$sitemap->editTime=filemtime($filePath);
						}
					}

				}

				$appDb->saveSitemap($sitemap,$contentList);

				if(isset($submitMessage) && $submitMessage!="")
					$_SESSION[($GLOBALS['siteId'])]['messageList'][]=$submitMessage;

			}
			else{
				$form->setErrorMessages();
			}

		}
		else{

			$contentList = $appDb->getSmEntryList($id,$pageList);

//Sorting by priority value
			foreach ($contentList as $key => $row) {
			    $sortValue2[$key]  = (int)$row['priorValue'];
			    $id2[$key] = $row['id'];
			}
			$sortValue2  = array_column($contentList, 'priorValue');
			$id2 = array_column($contentList, 'id');
			array_multisort($sortValue2, SORT_DESC, $id2, SORT_ASC, $contentList);

			$customData = $appDb->getCustomdata($id);

			$sitemap->fileType=$form->getValue('fileType');					
	
			if(isset($customData['start'])){
				$form->setValue('customDataStart',$customData['start']);
				$form->setValue('customDataEnd',$customData['end']);
				$sitemap->customDataStart=$customData['start'];
				$sitemap->customDataEnd=$customData['end'];
			}
			else{

				$defCustom1="";

				$defCustom1.="<url>\n";

				$defCustom1.="<loc>";
				$defCustom1.=str_replace("https","http",$GLOBALS['baseUrl']);
				$defCustom1.="</loc>\n";

				if($sitemap->lastMod!="None"){
					$defCustom1.="<lastmod>";
					$defCustom1.=date("Y-m-d", time());
					$defCustom1.="</lastmod>\n";
				}

				if($sitemap->changeFreq!="None"){
					$defCustom1.="<changefreq>";
					$defCustom1.=$form->getValue('changeFreq');
					$defCustom1.="</changefreq>\n";
				}

				if($sitemap->priorSwitch!="Disabled"){
					$defCustom1.="<priority>";
					$defCustom1.="0.5";
					$defCustom1.="</priority>\n";
				}

				$defCustom1.="</url>\n";
	
				$form->setValue('customDataStart',$defCustom1);
	
				$sitemap->customDataStart=$defCustom1;
	
			}

			for($i=0;$i<count($contentList);$i++){

				$contentUriList[]=$contentList[$i]['alias'];
				
			}
	
			for($i=0;$i<count($pageList);$i++){
				if(!in_array($pageList[$i]['alias'],$contentUriList)){
					$looseList[]=$pageList[$i];
				}
			}

			$xmlCode=$sitemap->getXmlCode($sitemap,$contentList);
			$form->setValue('output',$xmlCode);

		}

		return array(
			'id' => $id,
			'messages' => $messages,
			'form' => $form,
			'locList' => $pageList,
			'looseList' => $looseList,
			'contentList' => $contentList,
		);

	}

	public function deleteEvent()
	{

		$id = 0;
		if(isset($GLOBALS['urlParts'][2])){
			$id = $GLOBALS['urlParts'][2];
			$id=(int)$id;
			if(!is_integer($id))
				$id=0;
		}
		$messages=array();

		$modConfig=$this->modConfig;

		$Database=$this->dbConfig;
		$appDb = new AppDatabase($Database['app_db']);

		$sitemap = new Sitemap();
		$sitemap->id = $id; 
		$smData = $appDb->getSitemapDetails($id);

		if(count($smData)>0){
			$sitemap->convertDbData($smData);
		}
		else{
			$id = 0;
			$messages[]="Sitemap id is not correct.";
		}

		$deleted=false;

		$filePath=$sitemap->smPath.'/'.$sitemap->smFileName;

		if (isset($_POST['del'])) {
			$del = $_POST['del'];
			if ($del == 'Yes') {
				$deleted=$appDb->deleteSitemap($id);

				if(file_exists($filePath)){

					unlink($filePath);
				}

			}
		}

		return array(
			'id'    => $id,
			'messages' => $messages,
			'item' => $sitemap,
			'deleted' => $deleted,
		);

	}

}
