<?php

class AppDatabase extends DatabaseCms
{

	public $tablePrefix;

	public function __construct($dbData)
	{
		$this->dbId = new PDO('mysql:host=localhost;dbname='.$dbData['dbName'].';charset=utf8', $dbData['userName'], $dbData['userPassword']);
		$this->tablePrefix=$dbData['tablePrefix'];
	}

	public function getSitemapList()
	{

		$itemList=array();

		$this->dbId=$GLOBALS['db']['id'];
		$this->tablePrefix=$GLOBALS['db']['tablePrefix'];

		$value="";
		$sqlString="SELECT id, uri, value, integer_value";
		$sqlString.=" FROM ".$this->tablePrefix."core_misc_data";
		$sqlString.=" WHERE module_name = 'XmlSitemap' AND type = 'sitemapData'";
//echo "sqlString=";
//echo $sqlString;
//echo "<br>";

		$stmt = $this->dbId->prepare($sqlString);
		$stmt->execute();
		$resultSet = $stmt->fetchAll();

		foreach ($resultSet as $row) {

			$rowNew['smId']=$row['id'];

			$rowNew['smEdited']=$row['integer_value'];
			$rowNew['smPath']="";
			$rowNew['smFileName']="";
			$tempArr=explode(";",$row['uri'],2);
			$rowNew['smPath'] = $tempArr[0];
			$rowNew['smFileName'] = $tempArr[1];

			$tempArr2=explode(";",$row['value'],2);
			$rowNew['smCode']=$tempArr2[0];
			$rowNew['fileType']=$tempArr2[1];

			$itemList[] = $rowNew;
		}

		return $itemList;

	}

	public function getSitemapDetails($id)
	{

		$itemData=array();

		$value="";
		$sqlString="SELECT id, uri, value";
		$sqlString.=" FROM ".$this->tablePrefix."core_misc_data";
		$sqlString.=" WHERE module_name = 'XmlSitemap' AND type = 'sitemapData' AND id = ".$id."";
		$sqlString.=" LIMIT 1";
//echo "sqlString=";
//echo $sqlString;
//echo "<br>";

		$stmt = $this->dbId->prepare($sqlString);
		$stmt->execute();
		$resultSet = $stmt->fetchAll();

		foreach ($resultSet as $row) {

//		$smValue=$sitemap->smCode.";".$sitemap->fileType.";".$sitemap->changeFreq.";".$sitemap->lastMod.";".$sitemap->priorSwitch;
			$itemData['id']=$row['id'];
			$tempArr=explode(";",$row['uri'],2);
			$itemData['smPath']=$tempArr[0];
			$itemData['smFileName']=$tempArr[1];
			$tempArr=explode(";",$row['value']);
			$itemData['smCode']=$tempArr[0];
			$itemData['fileType']=$tempArr[1];
			$itemData['changeFreq']=$tempArr[2];
			$itemData['lastMod']=$tempArr[3];
			$itemData['priorSwitch']=$tempArr[4];
//			$itemData = $row;
		}

		return $itemData;

	}

	public function getWholeEntrySet($userRole)
	{
		$itemList=array();

		$sqlString="SELECT p.id AS id, p.title AS title, al.alias AS alias, p.edited AS edited";
		$sqlString.=" FROM ".$this->tablePrefix."core_resource r".", ".$this->tablePrefix."core_access ac";
		$sqlString.=", ".$this->tablePrefix."core_alias al".", ".$this->tablePrefix."mod_page p";
		$sqlString.=" WHERE r.id = ac.resource_id";
		$sqlString.=" AND r.id = al.resource_id";
		$sqlString.=" AND ac.role_id = :roleId";
//Access level can not be 0, which means no access for this role
		$sqlString.=" AND ac.access_level > 0";
//Access level can not be 2, which means meta tag noindex, nofollow
		$sqlString.=" AND ac.access_level != 2";
		$sqlString.=" AND r.source_id = p.id";
		$sqlString.=" AND r.type = 21";
		$sqlString.=" AND r.specific_name = 'view'";
		$sqlString.=" AND r.module_name = 'Page'";
		$sqlString.=" AND p.status = 1";


		$stmt = $this->dbId->prepare($sqlString);
		$stmt->execute(array(
			":roleId" => $userRole
		));

		$resultSet = $stmt->fetchAll();

		foreach ($resultSet as $row) {
			$row['status']="";
			$itemList[] = $row;
		}

		return $itemList;

	}

	public function getSmEntryList($id,$pageList)
	{

		$uriList=array();
		$prioritySet=array();
		$contentList=array();

		$sqlString="SELECT id, uri, value";
		$sqlString.=" FROM ".$this->tablePrefix."core_misc_data";
		$sqlString.=" WHERE module_name = 'XmlSitemap' AND type = 'entryData' AND integer_value = ".$id."";
//echo "sqlString=";
//echo $sqlString;
//echo "<br>";

		$stmt = $this->dbId->prepare($sqlString);
		$stmt->execute();
		$resultSet = $stmt->fetchAll();


		foreach ($resultSet as $row) {
			$uriList[] = $row['uri'];
			$prioritySet[($row['uri'])]=$row['value'];
		}

		foreach ($pageList as $row) {
			if(in_array($row['alias'],$uriList)){
				$contentItem=$row;
				$contentItem['status']="checked";
//				$contentItem['priorValue']=$prioritySet[((int)$row['alias'])];
				$contentItem['priorValue']=$prioritySet[($row['alias'])];
				$contentList[]=$contentItem;
			}
		}

		return $contentList;

	}

	public function getCustomData($id)
	{

		$customData=array();

		$sqlString="SELECT id, uri, value";
		$sqlString.=" FROM ".$this->tablePrefix."core_misc_data";
		$sqlString.=" WHERE module_name = 'XmlSitemap' AND type = 'customData' AND integer_value = ".$id."";
//echo "sqlString=";
//echo $sqlString;
//echo "<br>";

		$stmt = $this->dbId->prepare($sqlString);
		$stmt->execute();
		$resultSet = $stmt->fetchAll();

		foreach ($resultSet as $row) {
			$customData[($row['uri'])]=$row['value'];
		}

		return $customData;

	}

	public function insertSitemap($sitemap)
	{

		$id=0;

		$sqlString="INSERT INTO ".$this->tablePrefix."core_misc_data (module_name, integer_value, uri, type, value)";
		$sqlString.=" VALUES (";
		$sqlString.="'XmlSitemap'";
		$sqlString.=", 0";
		$sqlString.=", :smLocation";
		$sqlString.=", 'sitemapData'";
		$sqlString.=", :smValue";
		$sqlString.=")";

		$smLocation=$sitemap->smPath.";".$sitemap->smFileName;
		$smValue=$sitemap->smCode.";".$sitemap->fileType.";".$sitemap->changeFreq.";".$sitemap->lastMod.";".$sitemap->priorSwitch;
//		echo "sqlString=";
//		echo $sqlString;
//		echo "<br>";

		$stmt = $this->dbId->prepare($sqlString);

		$stmt->execute(array(
			":smLocation" => $smLocation,
			":smValue" => $smValue
		));

		$id=$this->dbId->lastInsertId();

		return $id;

	}

	public function updateSitemap($sitemap)
	{

		$curTime=time();

		$smLocation=$sitemap->smPath.";".$sitemap->smFileName;

		$smValue=$sitemap->smCode.";".$sitemap->fileType.";".$sitemap->changeFreq.";".$sitemap->lastMod.";".$sitemap->priorSwitch;

		$sqlString="UPDATE ".$this->tablePrefix."core_misc_data";
		$sqlString.=" SET ";
		$sqlString.="uri = :smLocation";
		$sqlString.=", value = :smValue";
		$sqlString.=", integer_value = :edited";
		$sqlString.=" WHERE module_name = 'XmlSitemap'";
		$sqlString.=" AND type = 'sitemapData'";
		$sqlString.=" AND id = :smId";

/*
echo "sqlString=";
echo $sqlString;
echo "<br>";
*/

		$stmt = $this->dbId->prepare($sqlString);
		$stmt->execute(array(
			":smLocation" => $smLocation,
			":smValue" => $smValue,
			":edited" => $sitemap->editTime,
			":smId" => $sitemap->id
		));

	}

	public function insertSmEntry($sitemap,$contentItem)
	{
		$entryId=0;

		$sqlString="INSERT INTO ".$this->tablePrefix."core_misc_data (module_name, integer_value, uri, type, value)";
		$sqlString.=" VALUES (";
		$sqlString.="'XmlSitemap'";
		$sqlString.=", :smId";
		$sqlString.=", :entryPath";
		$sqlString.=", 'entryData'";
		$sqlString.=", :priority";
		$sqlString.=")";
/*
echo "sqlString=";
echo $sqlString;
echo "<br>";

*/
		$stmt = $this->dbId->prepare($sqlString);
		$stmt->execute(array(
			":smId" => $sitemap->id,
			":entryPath" => $contentItem['alias'],
			":priority" => $contentItem['priorValue'],
		));

		$entryId=$this->dbId->lastInsertId();

		return $entryId;

	}

	public function updateSmEntry($sitemap,$contentItem)
	{

		$sqlString="UPDATE ".$this->tablePrefix."core_misc_data";
		$sqlString.=" SET ";
		$sqlString.="value = :priority";
		$sqlString.=" WHERE module_name = 'XmlSitemap'";
		$sqlString.=" AND type = 'entryData'";
		$sqlString.=" AND integer_value = :smId";
		$sqlString.=" AND uri = :entryPath";

//echo "sqlString=";
//echo $sqlString;
//echo "<br>";

		$stmt = $this->dbId->prepare($sqlString);
		$stmt->execute(array(
			":priority" => $contentItem['priorValue'],
			":smId" => $sitemap->id,
			":entryPath" => $contentItem['alias'],
		));

	}

	public function insertCustomEntry($sitemap,$entryCode)
	{
		$entryId=0;

		$sqlString="INSERT INTO ".$this->tablePrefix."core_misc_data (module_name, integer_value, uri, type, value)";
		$sqlString.=" VALUES (";
		$sqlString.="'XmlSitemap'";
		$sqlString.=", :smId";
		$sqlString.=", :entryCode";
		$sqlString.=", 'customData'";
		$sqlString.=", :value";
		$sqlString.=")";
/*
echo "sqlString=";
echo $sqlString;
echo "<br>";

*/
		if($entryCode=="start"){
			$value=$sitemap->customDataStart;
		}else{
			$value=$sitemap->customDataEnd;
		}

		$stmt = $this->dbId->prepare($sqlString);
		$stmt->execute(array(
			":smId" => $sitemap->id,
			":entryCode" => $entryCode,
			":value" => $value
		));

		$entryId=$this->dbId->lastInsertId();

		return $entryId;

	}

	public function updateCustomEntry($sitemap,$entryCode)
	{

		$sqlString="UPDATE ".$this->tablePrefix."core_misc_data";
		$sqlString.=" SET ";
		$sqlString.="value = :value";
		$sqlString.=" WHERE module_name = 'XmlSitemap'";
		$sqlString.=" AND type = 'customData'";
		$sqlString.=" AND integer_value = :smId";
		$sqlString.=" AND uri = :entryCode";

//echo "sqlString=";
//echo $sqlString;
//echo "<br>";
		if($entryCode=="start"){
			$value=$sitemap->customDataStart;
		}else{
			$value=$sitemap->customDataEnd;
		}

		$stmt = $this->dbId->prepare($sqlString);
		$stmt->execute(array(
			":value" => $value,
			":smId" => $sitemap->id,
			":entryCode" => $entryCode
		));

	}

	public function deleteSmEntry($smId, $uri)
	{

		$sqlString="DELETE FROM ".$this->tablePrefix."core_misc_data WHERE module_name = 'XmlSitemap' AND integer_value = :smId AND uri = :uri";
		$stmt = $this->dbId->prepare($sqlString);
		$stmt->execute(array(
			":smId" => $smId,
			":uri" => $uri
		));

	}

	public function saveSitemap($sitemap,$contentList)
	{

		$id = (int)$sitemap->id;

		if ($id == 0) {

			try {
				$this->dbId->beginTransaction();
				$id=$this->insertSitemap($sitemap);

				$this->dbId->commit();
			} catch (Exception $e) {
				$this->dbId->rollback();
			}

		} else {
			try {
				$this->dbId->beginTransaction();

//Update URL entries
				$dbEntryUriList=array();
				$formEntryUriList=array();
		
				foreach ($contentList as $contentEntry) {
		
					$formEntryUriList[]=$contentEntry['alias'];
					$entryId=0;
					$sqlString="SELECT id";
					$sqlString.=" FROM ".$this->tablePrefix."core_misc_data";
					$sqlString.=" WHERE module_name = 'XmlSitemap' AND type = 'entryData' AND uri = '".$contentEntry['alias']."' AND integer_value = ".$sitemap->id."";
					$sqlString.=" LIMIT 1";
					//echo "sqlString=";
					//echo $sqlString;
					//echo "<br>";
		
					$stmt = $this->dbId->prepare($sqlString);
					$stmt->execute(array(
		//					":bookId" => $book->id
					));
					$resultSet = $stmt->fetchAll();
			
					foreach ($resultSet as $row) {
						$entryId=$row['id'];
					}
		
		
					if($entryId==0){
						$this->insertSmEntry($sitemap,$contentEntry);
					}
					else{
						$this->updateSmEntry($sitemap,$contentEntry);
					}
		
				}
		
				$entryId=0;
				$sqlString="SELECT uri";
				$sqlString.=" FROM ".$this->tablePrefix."core_misc_data";
				$sqlString.=" WHERE module_name = 'XmlSitemap' AND type = 'entryData' AND integer_value = ".$sitemap->id."";
				//echo "sqlString=";
				//echo $sqlString;
				//echo "<br>";
		
				$stmt = $this->dbId->prepare($sqlString);
				$stmt->execute(array(
		//					":bookId" => $book->id
				));
				$resultSet = $stmt->fetchAll();
		
				foreach ($resultSet as $row) {
					$dbEntryUriList[]=$row['uri'];
				}

				foreach ($dbEntryUriList as $row) {
					if(!in_array($row,$formEntryUriList)){
						$this->deleteSmEntry($sitemap->id, $row);
					}
				}

//Update Custom data
				$entryId=0;
				$sqlString="SELECT id";
				$sqlString.=" FROM ".$this->tablePrefix."core_misc_data";
				$sqlString.=" WHERE module_name = 'XmlSitemap' AND type = 'customData' AND uri = 'start' AND integer_value = ".$sitemap->id."";
				$sqlString.=" LIMIT 1";
				//echo "sqlString=";
				//echo $sqlString;
				//echo "<br>";
	
				$stmt = $this->dbId->prepare($sqlString);
				$stmt->execute(array(
	//					":bookId" => $book->id
				));
				$resultSet = $stmt->fetchAll();
		
				foreach ($resultSet as $row) {
					$entryId=$row['id'];
				}
	
	
				if($entryId==0){
					$this->insertCustomEntry($sitemap,"start");
				}
				else{
					$this->updateCustomEntry($sitemap,"start");
				}

//---
				$entryId=0;
				$sqlString="SELECT id";
				$sqlString.=" FROM ".$this->tablePrefix."core_misc_data";
				$sqlString.=" WHERE module_name = 'XmlSitemap' AND type = 'customData' AND uri = 'end' AND integer_value = ".$sitemap->id."";
				$sqlString.=" LIMIT 1";
				//echo "sqlString=";
				//echo $sqlString;
				//echo "<br>";
	
				$stmt = $this->dbId->prepare($sqlString);
				$stmt->execute(array(
	//					":bookId" => $book->id
				));
				$resultSet = $stmt->fetchAll();
		
				foreach ($resultSet as $row) {
					$entryId=$row['id'];
				}
	
	
				if($entryId==0){
					$this->insertCustomEntry($sitemap,"end");
				}
				else{
					$this->updateCustomEntry($sitemap,"end");
				}

//Update Sitemap data

				$this->updateSitemap($sitemap);

				$this->dbId->commit();
			} catch (Exception $e) {
				$this->dbId->rollback();
			}

		}

		return $id;

	}

	public function deleteSitemap($id)
	{

		$delStatus=false;

		try {
			$this->dbId->beginTransaction();

			$sqlString="DELETE FROM ".$this->tablePrefix."core_misc_data WHERE module_name = 'XmlSitemap' AND type = 'sitemapData' AND id = :id";
			$stmt = $this->dbId->prepare($sqlString);
			$stmt->execute(array(
				":id" => $id
			));
	
			$sqlString="DELETE FROM ".$this->tablePrefix."core_misc_data WHERE module_name = 'XmlSitemap' AND type = 'entryData' AND integer_value = :id";
			$stmt = $this->dbId->prepare($sqlString);
			$stmt->execute(array(
				":id" => $id
			));

			$sqlString="DELETE FROM ".$this->tablePrefix."core_misc_data WHERE module_name = 'XmlSitemap' AND type = 'customData' AND integer_value = :id";
			$stmt = $this->dbId->prepare($sqlString);
			$stmt->execute(array(
				":id" => $id
			));

			$delStatus=true;

			$this->dbId->commit();
		} catch (Exception $e) {
			$this->dbId->rollback();
		}

		return $delStatus;

	}


	public function getValidityPatterns($modName)
	{
		$itemList=array();

		$sqlString="SELECT uri, value";
		$sqlString.=" FROM ".$this->tablePrefix."core_config";
		$sqlString.=" WHERE type = 'formValidationRegEx'";
		$sqlString.=" AND module_name = :modName";

		$stmt = $this->dbId->prepare($sqlString);
		$stmt->execute(array(
			":modName" => $modName
		));
		$resultSet = $stmt->fetchAll();

		foreach ($resultSet as $row) {
			$itemList[($row['uri'])] = $row['value'];
		}

		return $itemList;

	}

}
